#include <iostream>
#include <set>

#include "triangulation.h"
#include "point2d.h"
#include "ellipticfem2d.h"
#include "poisson2d.h"
#include "dirichletbc_rectangle.h"

using namespace std;

double
f(Point2D& x){
    return 1.;
}

double
d_bc_fct(Point2D& x){
    return 0.;
}

int main(){

    // Initialize and refine mesh
    //Triangulation mesh("coordinates.txt","elements.txt");
    //mesh.refineuniformly();
    //mesh.refineuniformly();
    
    Triangulation mesh("refined_coordinates.txt","refined_elements.txt");
    cout << "Refined Mesh has " << mesh.get_n_elements() << " elements " << endl;
    
    // Set Dirichlet boundaries:
    // Corners of domain
    Point2D lowerleftcorner(0.,0.);
    Point2D upperrightcorner(1.,1.);
    // All edges are Dirichlet boundaries
    set<int> d_bc_ids;
    d_bc_ids.insert(0);
    d_bc_ids.insert(1);
    d_bc_ids.insert(2);
    d_bc_ids.insert(3);
    // Initialize DirichletBC_Rectangle object
    DirichletBC_Rectangle d_bc(lowerleftcorner, upperrightcorner, d_bc_ids);
    
    // Initialize a Poisson problem
    Poisson2D poisson(f, d_bc_fct);
    
    // Initialize FEM model, solve and write solution to file
    EllipticFEM2D fem(mesh, poisson, d_bc);
    fem.solve();
    fem.write_solution_on_mesh("u_2d.txt");

}